
(* 

    Esta clase almacena el contenido de una pantalla de un PC en modo  texto 
 para poder recuperarse ms tarde.  

    Se usa as:
    
  VAR P:Pantalla;
  BEGIN
       P.Inicializar(80,25);
       P.Salvar;
       [tu programa]
       P.Recuperar
  END.

    Como  es una clase puedes tener todas las variables pantalla que quieras 
y en cada una almacenar una pantalla distinta,  teniendo en cuenta que  cada 
una  viene  a ocupar 4000 bytes de memoria una vez llamado a Salvar,  que se 
liberan al recuperar.  

*)


TYPE
PANTALLA = Object

    XPANT,YPANT:Integer;
    SalvaX,SalvaY:Integer;
    SegmenVid:Word;
    TamBufferVideo:Word;
    PtrSalva:^Word;
    PtrVideo:^Word;
    VideoSeg:Word;


FUNCTION MONOCROMO : Boolean;
{Devuelve True si estamos en un monitor monocromo}
PROCEDURE Salvar;
{Salva la pantalla en el Heap}
PROCEDURE Recuperar;
{Recupera la pantalla mostrndola}
PROCEDURE Mostrar;
{Recupera la pantalla mostrndola pero no libera memoria}
PROCEDURE Inicializar(X,Y:Integer);
{Inicializa diciendo el n de lneas y columnas sobre las que se est traba-}
{jando en el momento.Debe utilizarse con cualquier Objeto antes de usar nin-}
{guna de las otras funciones de la clase}


END;

FUNCTION Pantalla.MONOCROMO : Boolean; Assembler;
 ASM
  INT 17
  OR AX,30h
  CMP AX,30h
  JZ @CIERTO
  AND AX,AX
  JMP @FIN
  @CIERTO:
  MOV AX,1
  @FIN:
END;

PROCEDURE Pantalla.Salvar;
BEGIN
 SalvaX:=WhereX;
 SalvaY:=Wherey;
 TamBufferVideo:=XPant*YPant*2;
 GetMem(PtrSalva,TamBufferVideo);
 IF Pantalla.Monocromo THEN SegmenVid:=$B800 ELSE
                   SegmenVid:=$B000;
 PtrVideo:=Ptr(SegmenVid,0);
 MOVE(PtrVideo^,PtrSalva^,TamBufferVideo)
END;


PROCEDURE Pantalla.Recuperar;
BEGIN
Move(PtrSalva^,PtrVideo^,TamBufferVideo);
FreeMem(PtrSalva,TamBufferVideo);
GotoXY(SalvaX,SalvaY)
END;

PROCEDURE Pantalla.Mostrar;
BEGIN
Move(PtrSalva^,PtrVideo^,TamBufferVideo);
GotoXY(SalvaX,SalvaY)
END;

PROCEDURE Pantalla.Inicializar(x,y:Integer);
BEGIN
XPANT:=X;
YPANT:=Y;
END;

