Unit Utiles;

Interface

Uses Dos,Crt;

Const
     Vs = $B800;
     OutRedir: Boolean = False;    { Constante de Mejora_Exec }

Type Pal = Record                  { .Rojo, .Verde, .Azul }
 Rojo, verde, Azul : Byte;
End;

Type Linea_de_comandos = String[127];

Var
   Apuntador_a_comandos : ^Linea_de_comandos;
   Parametros : String;
   Cursor_Shape : Word;            { Variable para Init_Cursor/Restore_Cursor}
   Paleta : Array [0..255] Of Pal; { Array de la Paleta }
   Home_Directorio_String : String;

Function  Mayusculas (Linea:String) : String;
Function  Esta (Linea,Mascara:String) : Boolean;
Procedure Quita (Var Linea:String;Mascara: String);
Function  Sin_Espacios (Linea: String) : String;
Procedure Init_Cursor;
Procedure Restore_Cursor;
Function  ReadIn(Len : Byte;Fondo:Boolean) : String;
Function  Get_Password (L:Byte) : String;
Function  CheckPrinterStatus (Port : Word) : Byte;
Procedure Bg (Estado:Boolean);
Procedure WaitRetrace;
Procedure ScrollStr(message:string;x,y,txtcol,bckcol,highlight,
                    dlay,waitkey:word);
procedure SetChAttr(x, y, Fore,Back : byte);
procedure Shade(X1, Y1, X2, Y2, Fore,Back: byte);
Function  Rellenar_Espacios (Entrada:String; Long : Byte) : String;
Procedure Pide_Tecla;
Procedure Modo_Texto;
Procedure Modo_13;
Function  Home_Directorio : String;
Function  Depurar (S : String; Espacios: Boolean) : String;
Function  Fecha : String;
Procedure FadeToNegro (Velocidad:Byte);
Procedure FadeToPal   (Velocidad:Byte);
Procedure PonNegro;
Procedure RestauraPaleta;
Procedure GrabaPaleta;
Procedure PonColor(Color : Byte; R,G,B : Byte);
Procedure CogeColor(Color : Byte; Var R,G,B : Byte);
Function  SetOutput(Nombre_Fichero: PathStr): Boolean;
Procedure CancelOutput;
Implementation

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function Mayusculas (Linea:String) : String;
Var
   Indice : Integer;
Begin
   Mayusculas:=Linea;
   For Indice:=1 to Length(Linea) do Mayusculas[Indice]:=UpCase(Linea[Indice]);
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function Esta (Linea,Mascara:String) : Boolean;
Var
   Indice : Integer;
Begin
   Esta:=False;
   Linea:=Mayusculas(Linea);
   Mascara:=Mayusculas(Mascara);
   If Pos (Mascara,Linea)>0 then Esta:=True;
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Quita (Var Linea:String;Mascara: String);
Begin
 Mascara:=Mayusculas(Mascara);

 While Pos(Mascara,Mayusculas(Linea)) > 0 do
 Begin
    Delete (Linea,Pos(Mascara, Mayusculas(Linea)),Length(Mascara));
 End;
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function Sin_Espacios (Linea:String): String;
Var
   Aux : String;
Begin
Aux:=Linea;
Quita (Aux,' ');
Sin_Espacios:=Aux;
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Init_Cursor; ASSEMBLER;
ASM
  mov     ah,3
  xor     bh,bh
  int     10h
  mov     [Cursor_Shape],cx
  mov     ah,1
  mov     cx,2020h
  int     10h
end;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Restore_Cursor; ASSEMBLER;
ASM
  mov     ah,1
  mov     cx,[Cursor_Shape]
  int     10h
END;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function  ReadIn(Len : Byte;Fondo:Boolean) : String;
Const
    Caract_Fondo = '';
Var Inkey   : Char;
    InString: String[255];
    X,Indice : Byte;
Begin
 Instring:='';
 If Fondo Then
    Begin
    X:=WhereX;
    For Indice:=1 to Len Do Write (Caract_Fondo);
    GotoXY (X,WhereY);
    End;

 Repeat
  Inkey:=ReadKey;
  If (Inkey=#8)           and
     (Length(InString)>0) then
    Begin
       Dec(InString[0]);
       If Fondo Then Write(#8,Caract_Fondo,#8)
       Else Write(#8#32#8);
    End;
 If (Inkey<>#13) and
    (Inkey<>#8) and
    (Inkey<>#9) and
    (Inkey<>#27) then
    If Length(InString)<Len then
    Begin
       InString:=InString+InKey;
       Write(InKey);
    End
    Else
    Begin
       Sound (400);
       Delay(50);
       Nosound;
       Instring[Length(Instring)]:=Inkey;
       Write(#8,Inkey);
    End;
 Until Inkey=#13;
 WriteLn;
 ReadIn:=InString;
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function Get_Password (L:Byte) : String;
Const
  Valid : set of Char = [#32 .. #127];
  Hide1 = '';
  Hide2 = '';
VAR
  ch : Char;
  pwd : String;
  Cuenta:Byte;
BEGIN
  Pwd := '';
  For Cuenta:=1 to L do Write (Hide1);  { Escribe el Fondo de la linea }
  For Cuenta:=1 to L do Write (#8); { Retrocede a la 1 Pos ( #8= <-- ) }
  Cuenta:=0;
  REPEAT
    Ch := Readkey;
    IF ( (Ch IN valid) AND (Cuenta<L) ) THEN
    BEGIN
      Write(Hide2);
      Pwd := Pwd + Ch;
      Inc(Cuenta);
    END
    ELSE IF (Ch <> #13) THEN
         IF ( (Ch = #8) And (Cuenta>0) )Then
         Begin
            Delete (Pwd,Length(Pwd),1);
            Write (#8,Hide1,#8);
            Dec(Cuenta);
         End
         Else
         IF Ch = #0 THEN ReadKey { Elimina las Teclas Compuestas (Alt+A, etc) }
         Else
         Begin
            Sound (800);
            delay (100);
            Nosound;
         End;
  UNTIL (ch = #13);
  Get_Password := Pwd
END;









{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function CheckPrinterStatus (Port : Word) : Byte;Assembler;
{
 Status :    0 - time out            Returns the printer status
             1 - unused              ==========================
             2 - unused
             3 - I/O error
             4 - On line selected
             5 - Out of paper
             6 - Acknowledge
             7 - Not Busy

 2     : Printer not found
 3+4   : Printer not on line / selected
 3     : Printer not on line / selected
 4+5   : Cable not hooked up
 4+5+7 : Cable not hooked up
 3+6+7 : Printer off or unplugged
}
ASM
                MOV     DX,Port
                DEC     DX            {DX := Lpt -1                   }
                MOV     AX,$0200      {AH := $02 : Read printer status}
                INT     $17
                MOV     AL,AH         {Zet status in AL}
end;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Bg (Estado:Boolean);
Begin
If Estado Then
   ASM
      mov ax,1003h
      xor bx,bx
      int 10h
   END
ELSE
   ASM
      mov ax,1003h
      mov bx,0001
      int 10h
   END;
END;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure WaitRetrace; Assembler;
Asm
        mov     dx,3dah
@L1:
        in      al,dx
        test    al,08h
        jne     @L1
@L2:
        in      al,dx
        test    al,08h
        je      @L2
End;
{ +-----------------------------------------------------------------+ )
  | PROCEDURE ScrollStr(message:string;x,y,bckcol,txtcol,highlight, |
  |                     dlay,waitkey:word);                         |
  +-----------------------------------------------------------------+
  |   message   = message to be displayed (length = 2..75)          |
  |   x,y       = screen location (1..80, 1..25)                    |
  |   bckcol    = background color (0..7)                           |
  |   txtcol    = text color       (0..15)                          |
  |   highlight = highlight color  (0..15)                          |
  |   dlay      = time delay (milliseconds) (0..)                   |
  |   waitkey   = 0 - cycle once only                               |
  |               1 - continue cycle until a key is hit             |
  +-----------------------------------------------------------------+
  |  By Timothy M. Lasek - Electronic Exchange BBS @(315)786-0215   |
( +-----------------------------------------------------------------+ }

Procedure ScrollStr(message:string;x,y,txtcol,bckcol,highlight,
                    dlay,waitkey:word);
var l,direction: byte;
    c: char;
    anterior:Word;
begin
  Init_Cursor;
  direction:= 1;  l:= 1;
  gotoxy(x,y);
  anterior:=TextAttr;
  textattr:= txtcol+bckcol*16;
  write(message);
  while (keypressed=FALSE) AND (direction>0) do
  begin
     if direction=1 then
       begin
         inc(l);
         if l=length(message) then direction:= 2;
       end else
       begin
         dec(l);
         if l=1 then direction:= 1;
         if (WaitKey=0) AND (direction=1) then
         begin
           direction:=0;
           gotoxy(x,y);
           textattr:= highlight+bckcol*16;
           write(message[1]);
           delay(dlay);
         end;
       end;
     if direction>0 then
     begin
       gotoxy(x+(l-1),y);
       textattr:= highlight+bckcol*16;
       c:= message[l];
{       if (c>#96) AND (c<#123)
         then c:= chr(ord(c)-32);}
       write(c);
       textattr:= txtcol+bckcol*16;
       delay(dlay);
       gotoxy(x+(l-1),y);
       write(message[l]);
     end;
  end;
  gotoxy(x,y);
  textattr:= txtcol+bckcol*16;
  write(message);
  TextAttr:=Anterior;
  Writeln;
  Restore_Cursor;
end;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure SetChAttr(x, y, Fore,Back : byte);
begin
  Mem[VS:160*(Y-1)+2*(X-1)+1] := Fore + (Back shl 4);
end;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Shade(X1, Y1, X2, Y2, Fore,Back: byte);
Var
   IndiceX,IndiceY:Byte;
Begin
For IndiceX:=X1 to X2 do
    For IndiceY:=Y1 to Y2 do
        SetChAttr(IndiceX,IndiceY,Fore,Back);
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function Rellenar_Espacios (Entrada:String; Long : Byte) : String;
Var
   Indice:Byte;
   Aux   : String;
Begin
   Aux := Entrada;
   While Length(Aux)<Long do Aux:=' '+Aux;
   Rellenar_Espacios:=Aux;
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Pide_Tecla; ASSEMBLER;
ASM
   Mov AH,$10
   Int $16
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Modo_Texto; ASSEMBLER;
ASM
   Mov Ax,3
   Int $10
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Procedure Modo_13; ASSEMBLER;
ASM
   Mov Ax,$13
   Int $10
End;
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
Function  Home_Directorio : String;
Var
   Indice : Integer;
Begin
If Home_Directorio_String='' Then
For Indice:=Length(Paramstr(0)) DownTo 1 Do
   If Copy (Paramstr(0),Indice,1)='\' Then
      Begin
         Home_Directorio_String:=(Copy (Paramstr(0),1,Indice));
         Indice:=1;
      End;
Home_Directorio:=Home_Directorio_String;
End;
{=========================================================================}
Function  Depurar (S : String; Espacios : Boolean) : String;
Const
  Valid : set of Char = ['0'..'9', 'A'..'Z', 'a'..'z'];
Var
  Aux:String;
  Indice : Byte;
BEGIN
  Aux:='';
  For Indice:=1 to Length(S) do
    If ( (S[Indice]=' ') And (Espacios) ) Then Aux:=Aux+' '
    Else IF (S[Indice] IN valid) THEN Aux:=Aux+S[Indice];

  Depurar := Aux;
END;
{=========================== FECHA ==============================}
Function Fecha : String;
Var
   Anio,Mes,Dia,DiaSemana : Word;
   Anio_S,Mes_S,Dia_S : String[4];
Begin
  GetDate(Anio,Mes,Dia,DiaSemana);
  Str (Anio,Anio_S);
  Str (Mes ,Mes_S);
  Str (Dia ,Dia_S);

  If Dia<10 Then Dia_S:='0'+Dia_s+'/'
  Else Dia_S:=Dia_s+'/';
  If Mes<10 Then Mes_S:='0'+Mes_s+'/'
  Else Mes_S:=Mes_S+'/';

  Fecha:=Dia_S+Mes_S+Anio_S;

End;

{-------------------------  COGECOLOR  ----------------------------------}
Procedure CogeColor(Color : Byte; Var R,G,B : Byte);
Begin
 Port[$3c7] := Color;
 R := Port[$3c9];
 G := Port[$3c9];
 B := Port[$3c9];
End;
{-------------------------  PON COLOR  ----------------------------------}
Procedure PonColor(Color : Byte; R,G,B : Byte);
Begin
 Port[$3c8] := Color;
 Port[$3c9] := R;
 Port[$3c9] := G;
 Port[$3c9] := B;
End;
{-------------------------  PON NEGRO  ----------------------------------}
Procedure PonNegro;
Var i:Integer;
Begin
 For i:=0 to 255 do
 PonColor (i,0,0,0);
End;
{-------------------------  GRABA PALETA --------------------------------}
Procedure GrabaPaleta;
Var i: Integer;
Begin
 For i := 0 to 255 do
 CogeColor (I, Paleta [i].Rojo, Paleta [I].Verde, Paleta [i].Azul);
End;
{------------------------- RESTAURA PALETA ------------------------------}
Procedure RestauraPaleta;
Var i:Byte;
Begin
 For i:=0 to 255 do
 PonColor (i, Paleta[i].Rojo, Paleta [i].Verde, Paleta [i].Azul);
End;
{-------------------------  FADE TO PAL  --------------------------------}
Procedure FadeToPal (Velocidad:Byte);
Var i,j: Byte;
 Tmp : Array [1..3] of Byte;
Begin
 For i:=1 to 64 do Begin
 For j:=0 to 255 do Begin
 CogeColor (j,Tmp[1],Tmp[2],Tmp[3]);

 If Tmp[1]<Paleta[j].Rojo then inc (Tmp[1]);
 If Tmp[2]<Paleta[j].Verde then inc (Tmp[2]);
 If Tmp[3]<Paleta[j].Azul then inc (Tmp[3]);

 PonColor (j,Tmp[1],Tmp[2],Tmp[3]);
 End;
 Delay (Velocidad);
 End;

End;
{------------------------- FADE TO NEGRO --------------------------------}
Procedure FadeToNegro (Velocidad : Byte);
VAR i,j:Byte;
 Tmp : Array [1..3] of Byte;
BEGIN

 For i:=1 to 64 do Begin
 For j:=0 to 255 do Begin

 CogeColor (j,Tmp[1],Tmp[2],Tmp[3]);
 If Tmp[1]>0 then dec (Tmp[1]);
 If Tmp[2]>0 then dec (Tmp[2]);
 If Tmp[3]>0 then dec (Tmp[3]);

 PonColor (j,Tmp[1],Tmp[2],Tmp[3]);
 End;
 Delay (Velocidad);
 End;
End;

{------------------------- SET OUTPUT -----------------------------------}

Function SetOutput(Nombre_Fichero: PathStr): Boolean;
begin
 Nombre_Fichero:=Nombre_Fichero+#0;
 SetOutput:=False;
 asm
 push ds
 mov ax, ss
 mov ds, ax
 lea dx, Nombre_Fichero[1]
 mov ah, 3Ch
 int 21h
 pop ds
 jnc @@1
 ret
@@1:
 push ax
 mov bx, ax
 mov cx, Output.FileRec.Handle
 mov ah, 46h
 int 21h
 mov ah, 3Eh
 pop bx
 jnc @@2
 ret
@@2:
 int 21h
 end;
 OutRedir:=True;
 SetOutput:=True;
end;

{------------------------- CANCEL OUTPUT -------------------------------}

procedure CancelOutput;
var
 Nombre_Fichero: String[4];
begin
 if not OutRedir then Exit;
 Nombre_Fichero:='CON'#0;
 asm
 push ds
 mov ax, ss
 mov ds, ax
 lea dx, Nombre_Fichero[1]
 mov ax, 3D01h
 int 21h
 pop ds
 jnc @@1
 ret
@@1:
 push ax
 mov bx, ax
 mov cx, Output.FileRec.Handle
 mov ah, 46h
 int 21h
 mov ah, 3Eh
 pop bx
 int 21h
 end;
 OutRedir:=False;
end;



{=========================================================================}

Begin
Home_Directorio_String:='';

Apuntador_a_Comandos := Ptr(PrefixSeg, $80);
Parametros:=Copy( Apuntador_a_Comandos^,1,Length(Apuntador_a_Comandos^) );

End.
